/*****************************************************************
 *
 * DeviceConfig.h
 * Device Configuration Handler
 *
 * Author: Govind Kothandapani <govindk@ami.com>
 *       : Rama Bisa <ramab@ami.com>
 *       : Basavaraj Astekar <basavaraja@ami.com>
 *       : Bakka Ravinder Reddy <bakkar@ami.com>
 *
 *****************************************************************/
#ifndef DEVICE_CONFIG_H
#define DEVICE_CONFIG_H

#include <stdio.h>
#include "MsgHndlr.h"
#include "com_IPMI_DeviceConfig.h"

/**
 * @var g_Config_CmdHndlr
 * @brief Transport Configuration Commands Map.
**/
extern const CmdHndlrMap_T  g_Config_CmdHndlr [];


/**
 * @defgroup devcfg Device Configuration Module
 * IPMI Device Configuration command interface. This module
 * implements configuration and access commands for transport modules
 * such as LAN, Serial/Modem, Serial Over LAN.
 * @{
**/
/** @} */

#endif  /* DEVICE_CONFIG_H */
