/****************************************************************
 ****************************************************************
 **                                                            **
 **    (C)Copyright 2005-2006, American Megatrends Inc.        **
 **                                                            **
 **            All Rights Reserved.                            **
 **                                                            **
 **        6145-F, Northbelt Parkway, Norcross,                **
 **                                                            **
 **        Georgia - 30071, USA. Phone-(770)-246-8600.         **
 **                                                            **
 ****************************************************************
 *****************************************************************
 *
 * lanconfig.h
 * Lan configuration command handler
 *
 * Author: Bakka Ravinder Reddy <bakkar@ami.com>
 * 
 *****************************************************************/
#ifndef LANCONFIG_H
#define LANCONFIG_H

#include "com_BmcType.h"
#include "com_IPMIDefs.h"
#include "com_IPMI_LANConfig.h"





/**
 * @defgroup lcc LAN Configuration Command handlers
 * @ingroup devcfg
 * IPMI LAN interface configuration command handlers.
 * Get/Set commands allow retrieval and updation of various LAN parameters.
 * @{
**/
 int SetLanConfigParam  (  uint8_t* pReq, uint8_t ReqLen,   uint8_t* pRes );
// int GetLanConfigParam  (  uint8_t* pReq, uint8_t ReqLen,   uint8_t* pRes );
// int SuspendBMCArps (  uint8_t* pReq, uint8_t ReqLen,   uint8_t* pRes );
// int GetIPUDPRMCPStats (  uint8_t* pReq, uint8_t ReqLen,   uint8_t* pRes );

/** @} */

/**
 * @brief Initialize LAN Configuration Data.
**/
// void InitLanConfigData(void);

/**
 * @brief Update ARP Status information.
 * @param EthIndex - Ethernet index
 * @param IsTimerRunning - indicates timer state.
**/
// uint8_t UpdateArpStatus   (uint8_t EthIndex, BOOL IsTimerRunning, int BMCInst);

/**
 * @brief Gratuitous ARP generation task. 
**/
// void* GratuitousARPTask (uint8_t *Addr);

#endif /* LANCONFIG_H */
